*  Pixie & Dixie  launcher
* HAGA    version -  with GOS4 


* New Hi-color displaying
* ST(E):  320x240 overscan, 54c/l Cyg mode
* Single palette


* This must work on TT, Falcon with 2MB RAM
*  with  68030 PMMU swap 


* This version with 1 GOS launcher file containing packed TOS executable
* Read-ahead cache for other files, reading during gameplay
* which reads from image file containing data files

* HAGA function offsets - always 2x function #



*  detHW -  0
*  showHW - 2
*  pmmuSet -4
*  setSHW   - 6    user settings for MSTE, Falcon, TT as cache etc.
*  fileRW    - 8   
*  exitToD    - 10
*  stateSave  - 12
*  restoreState  - 14 
*  commentShow  -  16
*  commentEdit   -  18
* Above 2 only from statesave files
*  loadGos4  -  20
*  loadGos5  -  22
* Above may be used from here for smooth load
* but in this is disabled






* typical call :  
*  	lea	hagaLD(pc),a1
*	move.w	4(a1),d1     -  PMMU set call
*	jsr	0(a1,d1.w)




******************************************
* Game specific constants, locations :


gIkbdSet	equ	$01150000    *   Joystick interrogation    mode
* first byte is count (max 3), then IKBD command, params
* For joystick mode enter above $01140000
* For joystick interrogation mode enter above $01150000
* For mouse mode enter above $01080000
* If game has mouse and joystick mode selectable enter: $01920000 - query mode



* By some games there is extra option for TT slowdown setting
* what is not needed in most of games



 * Enter here actual length of file:

initClen	equ	36200    * Init code len - len of GOS launcher file  
* max length is about 220KB for 512K games


gamFileSize	equ	551398   * For loading after start - Here no such



* label   gamex  -  set keys for DeskEx and StateSave etc .


* At bottom need to edit by need txt messages for DeskEx, Gamex keys
* then Cheat message(s)
* and  Photochrome/HST pic filename


* Conditional assembly variables :

* Use IFNE for cond. met=1 , and IFEQ for not met=0  !


ram1m    equ      0    * 1  if game needs 1MB RAM, otherwise 0 - for 512K

gxIkbg	equ	1     *  1  if game uses TOS for IKBD read, otherwise 0 

titPic     equ    0   * If there is title pic shown before game start, otherwise 0 


******************************************









beginL        *Beginning of program



* First load HAGA in free RAM and call HW detect :


* Normally load from shared DIR, but first look in current DIR ! :
* With this can have special HAGA for game needing something extra

	
	clr.w	-(a7)
	pea	hagln(pc)
	move.w	#$3D,-(a7)
	trap	#1
	addq.l	#8,a7
	move.w	d0,d7
	bpl.s	loadHagab

* If no - Load from common DIR C:\GAMEX :
	
	
	clr.w	-(a7)
	pea	chagln(pc)
	move.w	#$3D,-(a7)
	trap	#1
	addq.l	#8,a7
	move.w	d0,d7
	bmi	exitu
		
loadHagab	pea	hagaLD
	pea	14000    *  May grove !
	move.w	d7,-(a7)
	move.w	#$3F,-(a7)
	trap	#1
	lea	12(sp),sp

	move.w	d7,-(a7)
	move.w	#$3E,-(a7)
	trap	#1
*	addq.l	#4,a7



	lea	hagaLD-4,sp

* Going supervisor :

	clr.l	-(sp)
	move.w	#32,-(sp)
	trap	#1



	





* Call HWtest, with initial settings :
* Here may test version and abort if not good
* Version is at pos 254:  byte V Major, byte V minor  .

	
	lea	inHWsets(pc),a0
	moveq	#0,d0
	lea	hagaLD,a1
	move.w	(a1),d1
	jsr	0(a1,d1.w)

* Struct :

* 0 -  TOS v major
* 1 - TOS v minor
* 2 - RAMsize in 512KB steps
* 3 -  HW (1-ST, 2-STE,3-MSTE,4-Falcon,5-TT)
* 4 - MSTE clock at start
* 5 -  MSTE clock set
* 6 -  Lang code
* 7 - Real RAM size    (again 512KB step)
* 8 - 68030 flag
* 9 - falccach1
* 10 - falccach2    (11 bytes so far)

* Need some hard disk infos too !  - using PUN and XBRA .

* 11- punDesc for current drive - should describe IF type !

*  00-$07    ACSI  
*  08-$0F     SCSI
*  $10-$11   IDE

* 12 - XBRA param, should flag is smooth load available
* call checked for presence of D15 file too .

* 13 - Smooth enabled - must set for each game, later ...

* a0 returned points to struct begin !


* If not enough RAM abort :

	move.b	7(a0),d4

  IFEQ  ram1m
	cmp.b	#2,d4
  ENDC

  IFNE  ram1m
	cmp.b	#4,d4
  ENDC

	bcs	noEnoR


* Copy some params for later usage :

	move.b	8(a0),falcfl
	move.b	7(a0),physRam
	move.b	3(a0),machin+3


* Here may perform low RAM usage test and abort :

* Calc total RAM usage :

	lea	hagaLD(pc),a1   * this is low RAM usage in fact
* with some overshot

	add.l	#$8000,a1   * HAGA space

* Add GOS len - 91 KB if used ....

	add.l	#93184,a1

* 1MB RAM case :

	cmp.b	#2,d4
	bne.s	.not1M

	cmp.l	#310000,a1
	bcc	.to

.not1M	
	cmp.b	#4,d4
	bne.s	.not2M

* Here we have max 2x512K for TOS save and SwapSpace !
* What means that by 2MB games used space must be less !

	cmp.l	#450000,a1
	bcc	.to

.not2M
	cmp.l	#1350000,a1   * may be less if large image !

.to	bcc	tooMLR






* Game specific :
* IKBD mode settings for restore :

ikbdMode		move.l	#gIkbdSet,50(a0)   * 

* first byte is count (max 3), then IKBD command, params
* Or maybe if first is negative then other 3 bytes are 24 bit addres
* with longer ....  later

* SaveLen :

    IFEQ  ram1m
	move.l	#$7FFF8,54(a0)
    ENDC

    IFNE  ram1m
	move.l	#$FFFF8,54(a0)
    ENDC




* Set screen to $1F8000 , ST low :
* or $78000 if only 2 or 1MB

	dc.w 	$A00A       * Hide mouse

InitScrB	equ	$1F8000  * for 4MB min

   IFEQ  ram1m
InitScrB1M	equ	$78000
   ENDC

   IFNE  ram1m
InitScrB1M	equ	$F8000
   ENDC


* Mono support too :

* Get current screen resolution:

	move.w	#4,-(sp)
	trap	#14
	addq.l	#2,sp
	
	cmp.w	#3,d0   *Allow only  0-2 !
	bcs.s	store_res
	clr.w	d0

store_res 	move.w	d0,DeskRes


	cmp.w	#1,d0    * med. res. ?
	bne.s	setScreen1
	moveq	#0,d0

setScreen1	
	lea	InitScrB,a1
	cmp.b	#8,physRam
	bcc.s	min2mp
	lea	InitScrB1M,a1

min2mp	move.l	a1,screnb   *screen pos. for pic show

	move.w	d0,-(sp)
	pea 	(a1)
	pea	(a1)
 	move.w	#5,-(sp)
	trap	#14
	lea	12(sp),sp




* Set some colors:

	cmp.w	#2,DeskRes
	beq.s	inMh

	pea	hwpal(pc)
	move.w #6,-(sp)
	trap  #14
	addq.l	#6,sp
	
	move.w  #37,-(sp)
	trap  #14
	addq.l  #2,sp

inMh







* Move HAGA in high RAM :

hagaHP4	equ	$3F8000    * 
hagaHP2	equ	$1F8000    * 32K for Haga and below a lot for TOS save
hagaHP1	equ	$F8000  
* TOS save goes in case of 68030 , 4MB min :  area 2MB-3MB 
* If longer than 1MB part remains on loc at 1MB.  Game should
* not write there !  So, with 4MB max occupied RAM is some 1.8 MB 
* on 68030 machines !
* PMMU swap is with 1MB blocks - 0-$100000  and  $200000-$300000

* If TT with 2 MB then TOS goes to area 1MB-1.5MB
* max RAM occupied about 420KB . Good for Hddriver with 10,10,100 settings.
* and Fast RAM (+64KB usage) .
* PMMU swap is with 512KB blocks - 0-$80000  and  $100000-$180000

* On ST(E) TosSave goes always right below HAGA.
* Below TosSave goes GOS, if installed
* or slowSWshift space - same len as TosSave - if more than 1MB RAM .
* for faster swapping.
* Below it is free Workspace

* On ST(E) with only 1MB no SlowSWshift space, using 3 step swap
* Still, 200KB of RAM may remain free, with GOS installed
* Actually, it is possible to have SlowSWshift too, if not too much
* low RAM is occupied ....  maybe later ....





  * up to $C0000, where TOS save space is
* what may be therefore max 256KB - enough for TOS 2.06 ($18872) +
* not too economic hard disk driver - max some 160 KB total usage from ...


	lea	hagaHP4,a1
	cmp.b	#4,physRam
	bcs.s	only1M1
	cmp.b	#8,physRam
	bcc.s	toStoHfp
	lea	hagaHP2,a1
	bra.s	toStoHfp
only1M1	lea	hagaHP1,a1
toStoHfp
	move.l	a1,hagaFp

	lea	hagaLD,a0
	move.w	#3500,d1
.hu	move.l	(a0)+,(a1)+
	dbf	d1,.hu





*


	bsr	clearkb 


	move.w	#34,-(sp)   *  Kbdvbase
	trap	#14
	addq.l	#2,sp

	move.l	d0,a1
	lea	32(a1),a1   * Statvec
	move.l	a1,backSv+2

	move.l	(a1),statVec+2
	move.l	#mySv,(a1)


repSh	move.w  #37,-(sp)
	trap  #14
	addq.l  #2,sp




	
tomap	move.l	hagaFp(pc),a1
	move.w	2(a1),d1
	jsr	0(a1,d1.w)    *HW detected show



	lea   	gamext(pc),a0
	bsr  	pmess

	
	lea	cheatt(pc),a0
	bsr	pmess




*	cmp.b	#5,machin+3
*	bne.s	disSlow

*	pea	ttSpeedT(pc)
*	move.w	#9,-(sp)
*	trap	#1
*	addq.l	#6,sp

*	bra.s	litPau

disSlow








litP
*Little pause to see it:
	move.w	#1177,d7

dell1	move.w  #37,-(sp)
	trap  #14
	addq.l  #2,sp

* Allow abort with keypress:
	pea	$600ff
	trap	#1
	addq.l	#4,sp 
	tst.b	d0
	beq.s	wait_k

*	cmp.b	#"3",d0
*	blt.s	seeMk

*	cmp.b	#"9",d0
*	bgt.s	seeMk

*	move.b	d0,ttSpeedT+11
*	bra.s	repSh
	
seeMk


	
	cmp.b	#"M",d0
	beq	megastes
	cmp.b	#"m",d0
	beq	megastes

	cmp.b	#"L",d0
	beq.s	set_inf
	cmp.b	#"l",d0
	beq.s	set_inf 
	
*	cmp.b	#"S",d0
*	beq.s	set_infa
*	cmp.b	#"s",d0
*	beq.s	set_infa

		
*	cmp.b	#"B",d0
*	beq.s	set_infb
*	cmp.b	#"b",d0
*	beq.s	set_infb

	bra.s	toPicsh

wait_k	dbf	d7,dell1
	bra.s	toPicsh




*set_infa	st	unlf+1
*	bra.s	toPicsh

*set_infb	st	unlf+1
	
set_inf	st	unlf
*	bra.s	toPicsh

toPicsh

*	cmp.b	#5,machin+3
*	bne.s	nott2

*	moveq	#0,d0
*	move.b	ttSpeedT+11(pc),d0
*	sub.b	#"0",d0
*	move.l	#108000,d1    * Game depending !
*	divu	d0,d1
*	move.w	d1,slowF
*nott2



* Need to wait release of pressed key 


	bsr.s	waitRel

	move.l	hagaFp(pc),a2
	move.b	$80(a2),d2   * TOS v major
	cmp.b   	#3,d2
	bne.s	seeFalc    * picshow on TT ?
ntR	bsr	ttShow
	bra.s      	loadg   



megastes	* Call HAGA function :

	move.l	hagaFp(pc),a1
	move.w	6(a1),d1    * User settings call
	jsr	0(a1,d1.w)

	bra	tomap


* Wait key release - otherwise repeating by DeskEx :

waitRel	

	tst.b	relFlag
	bne.s	waitRel
	rts



mySv

	

statVec	jsr	0   *

* Need d0  negative , as release signal

	tst.b	d0
	bmi.s 	released
	
	st	relFlag  * Key pressed flag
	rts


released	clr.b	relFlag
	rts

backSv	
	lea	0,a1   *
	move.l	statVec+2(pc),(a1)
	rts

relFlag	dc.b	0,0




seeFalc
 	cmp.b   #4,d2
	bne.s	steph   *to ST(E) show

* Falcon Pic show: 

	jsr    falcpic 
	bra.s      loadg

steph         jsr    photoc    *Call Photochrome pic show rut., on (M)ST(E)




 	

loadg	bsr.s	waitRel

                bsr.s	backSv   *



*	cmp.b	#4,machin+3   * Falcon ?
*	bne.s	notF1

* What monitor ?  :

*	move.w	#89,-(sp)
*	trap	#14
*	addq.l	#2,sp

*	cmp.w	#2,d0
*	seq	falcfl+1      * flag for VGA on falc

*notF1



* Set path to subDIR "FILES" :


	pea	subdif(pc)
	move.w	#59,-(sp)
	trap	#1
	addq.l	#6,sp



*  RAM config, TOS save etc via HAGA func :

   

	moveq	#4,d0      * GOS 4
	clr.b	d2    * no smooth  - 

   IFEQ  ram1m
	lea	$80000,a3    * RAM used by game - for 512KB
   ENDC

   IFNE  ram1m
	lea	$100000,a3    * RAM used by game - for 1M
   ENDC

	lea	hwpal(pc),a4
*	sub.l	a0,a0    * no image file
	lea	gamFileSize,a0 
	move.l	#launLen,d7



	move.l	hagaFp(pc),a1   * High RAM 
	move.w	26(a1),d1     * RAMconfig call
	jsr	0(a1,d1.w)



* here need to fill/correct cache params after HAGA call !

	move.l	(a0)+,cachPos
	move.l	(a0)+,cachSiz
	move.w	(a0)+,fullDat





launLen	equ	initClen  


*  load what needs to be loaded right now, before killing TOS :


	clr.w	-(a7)
	pea	laun(pc)
	move.w	#$3D,-(a7)
	trap	#1
	addq.l	#8,a7
	move.w	d0,d7
	bmi	exitu


	move.l	cachPos(pc),a1	
	

	pea	(a1)
	pea	launLen  *** ++
	move.w	d7,-(a7)
	move.w	#$3F,-(a7)
	trap	#1
	lea	12(sp),sp

	move.w	d7,-(a7)
	move.w	#$3E,-(a7)
	trap	#1
	addq.l	#4,a7






* PMMU settings call :

* of course only if there is 68030 - ....

	move.l	hagaFp(pc),a1   * High RAM 
	moveq	#0,d0    * Default settings  - Must set for future v.
	move.w	4(a1),d1
	jsr	0(a1,d1.w)









* Flush IKBD ACIA buffer - may be blocked
aciafl1        btst    #0,$FFFFFC00.w 
	beq.s    aciaempt1
	tst.b     $FFFFFC02.w
	bra.s     aciafl1
aciaempt1  



	



lau_2	


* Load GOS4 :

* Haga function need to set GOS4 location 

* Guideline:  on ST(E) right below  TOS save
* On TT, Falcon  right below  HAGA , so will have max
* WS in area 0.5-1M or 2M 

* But if PP driver is available it is little different - for GOS5 and smooth load - here not used


	move.l	hagaFp(pc),a1   * High RAM 
	move.w	20(a1),d1
	jsr	0(a1,d1.w)

	tst.b	d0
	bne	exitu


	move.w	#$2700,sr


   IFEQ  ram1m
	move.l	#$80000,$42E.w   * Phystop for game
   ENDC

   IFNE  ram1m
	move.l	#$100000,$42E.w   * Phystop for game
   ENDC






* Need to invert colors if mono on Falcon :

*	cmp.w	#2,DeskRes
*	bne.s	noCinv

*	cmp.b	#4,machin+3	
*	bne.s	noCinv


*	lea	$FFFF9800.w,a1
*	clr.l	(a1)+
*	move.l	#$FFFFFFFF,(a1)
	

*	move.w	#$4E71,backingam

*noCinv



 

* Only on Falcon, only if VGA :

*	move.b	falcfl+1(pc),d1
*	beq.s	notFalc   * not VGA

* Correct Videl setting :   

*	move.w	#$03AD,$FFFF82AA.w
* Otherwise unsynced palette change controlled by Timer B !


*notFalc  


* Copy gamex code to place :


   IFEQ   gxIkbg
	clr.w	$6130.w
   ENDC

   IFNE   gxIkbg
	move.w	#$E6E5,$6130.w
   ENDC

	lea	gamex(pc),a1
	lea	$6132.w,a2
	moveq	#100,d2
.co	move.l	(a1)+,(a2)+
	dbf	d2,.co




	move.l	unlf(pc),$600.w    

	cmp.b	#5,machin+3
	bne.s	nott2   
	st	$602.w   * set TT slowdown on
nott2 
	

* Must give other infos to launcher :
* like hagaFp  and cachPos  :

	move.l	hagaFp(pc),$608.w
	move.l	cachPos(pc),$60C.w
	move.l	cachSiz(pc),$610.w
	move.w	fullDat(pc),$614.w



	clr.b	$612F.w
	

* Must give pos and len of launcher :

ldAdr	move.l	cachPos(pc),a0   ***
	lea	launLen,a2    * len of launcher ++
	move.l	hagaFp(pc),a1   * High RAM 
	move.w	24(a1),d1
	jmp	0(a1,d1.w)    * Start GOS4 and game too






cachSiz	dc.l	200000   * Min some 200KB for 1MB machines
fullDat	dc.w	1    * if not 0 then load whole file
maxDat	dc.l	gamFileSize






machin	ds.b 10


falcfl	dc.w    0



unlf	dc.w   	0
slowF	dc.w	0    * For TT slowdown  - if not TT here 0 

physRam	dc.w	0









* Desktop exit key watch :


* Jumped from   - relocatible
* Link must be done in launcher ! - if not TOS kb. reading

gamex		

* Jumped from   - TOS keyboard read in some cases 

   IFEQ  gxIkbg
	cmp.b   #$E5,d0   * For /, 
	beq.s    gamex_w

	cmp.b   #$E6,d0   * For * on NumPad, 
	beq.s    toDeskEx
  
gamnoex 	
	* here put code for particular game !

	move.b	#$FF,d1
	rts

     ENDC


   IFNE  gxIkbg
	bra.s	toDeskEx   * for GOS key watch
	bra.s	gamex_w
   ENDC




*toGnox

backingam
	move.l	a0,-(sp)
	move.l	cachPos(pc),a0
	subq.l	#4,a0
	cmp.l	#"cVal",(a0)
	seq	$612F.w


	move.l	(sp)+,a0

  IFEQ  gxIkbg
	bra.s	gamnoex
   ENDC

  IFNE  gxIkbg
	rts
   ENDC



toDeskEx	   *  go via pos save code, with d0=55
	
	movem.l	d0-d7/a0-a6,-(sp)

	move.l	cachPos(pc),a0
	subq.l	#4,a0
	clr.l	(a0)   * force reload for case


	moveq	#55,d0
	bra.s	gexCom




* Following must be in Deskex block - as is readen from moved loc

   IFEQ  ram1m
cachPos	dc.l	$81000    * actually final RAMdisk pos - variable
   ENDC

   IFNE  ram1m
cachPos	dc.l	$101000
    ENDC


*Save state  


	

	
gamex_w   *Exiting game with storing state 

* Code for game state store when exit is requested:





GameSto    * The code itself. Must be PC relative !!!

* Presumable we are in supervisor mode....
* For games not running in SV need some switch, workaround...
* will see later....


* 	0	USP
*  	4	Cur screen resolution - almost always 0 !
*	6	SSP
*	10	Palette, 32 bytes
*	42	MFP state, 24 bytes
*	66	Screen base
*	70	IKBD joy status, 8 bytes
*	80	SR,  2 bytes
* 	84	PSG status, 14 bytes
*	100	IKBD mouse status, 8 bytes
*	108	STE DMA , 8 bytes



ikbdof	  equ	70
ikbdm_of    equ      100
srofs	  equ	80
psgofs       equ	84
stedmaof    equ      108	

* Store CPU regs, SR, stack pointers
	

	movem.l	d0-d7/a0-a6,-(sp)

	move.l	cachPos(pc),a0
	subq.l	#4,a0
	move.l	#"cVal",(a0)  * to prevent reload by statesave ret.


	moveq	#0,d0    * Only default ST saves needed
gexCom	lea	GameStat(pc),a0
	move.w	sr,80(a0)
	move.w	#$2700,sr


* Continuing in HAGA function :

* Needed parameters:

* backingam adress, GameStat address ... ?

	lea	backingam(pc),a2

	move.l	hagaFp(pc),a1   
	move.w	12(a1),d1
	jsr	0(a1,d1.w)




hagaFp	dc.l	0  ***
* Must right after HAGA func call, with jsr
* so will have hagaFp var loc ! This helps in running snap on diff
* RAM size !

*backingam	rts



*parlist	ds.b     28   * if no place here, may in high RAM too !
* or best, reserve place in HAGA self !!!!

*******




GameStat

* Space at here free by gameplay - when copied in game space




*****





















depak3	clr.l d0
	moveq    #6,d4
	moveq    #$3f,d5   *for masking bits 5-0

* Bit meaning:  7 - if set it's back referrer , if 0 then bits
* 6-0 give count of literals to copy
* if all bits are 0 it is terminator

* When bit 7 set, bit 6: if 1 then long distance back given by 2 following byte
*  bit 6: when 0  then short distance given by following 1 byte
*  bits 5-0  count of bytes referred. 
*  By short refer.  0 means 3, 1 means 4, etc  up to 66 .
*  By long refer.  0 means 4, 1 means 5, etc  up to 67 .


main3 	clr.w d0 *prep for dbf
	move.b (a1)+,d0
	bmi.s back3 
	beq.s nom3 *end
	subq.w #1,d0 *compens dbf
litc 	move.b (a1)+,(a4)+
	dbf d0,litc
	bra.s main3

nom3	rts

back3	move.b d0,d2
	and.w d5,d2 *d5=$3f
* Test is long or short referrer:
	btst    d4,d0   *test bit 6
	bne.s  longr
	
	addq.w #2,d2 *compens	
displl	move.b (a1)+,d0 * displac
calcadr	move.l a4,a2
	sub.l d0,a2
baksl	move.b (a2)+,(a4)+
	dbf d2,baksl
	bra.s main3

longr	addq.w #3,d2 *compens
	move.b (a1)+,d0 * displac
	lsl.w  #8,d0   *MSB
	bra.s   displl

* End of C3 depak

* End of code for moving up .






**********************






	







* Settings :
* 0 - MSTE clock  0 or non 0 for 16MHz
* 1 - Falcon bus settings
* 2 - Falcon cache settings, word
* 4 - TT cache settings, word
* 6 - TT bus settings
* 7 - spare

* Initial HW settings, may be changed if press M, and screw it up too :-)
inHWsets  dc.b  0,$40,8,9,8,8,0,0    * 

* above means:
* MSTE 16MHz ;  Falcon 16MHz, STE bus emul ; 
* Falcon cache instr, on, data off ; TT cache instr off, data off ;
* TT bus - default - 24 bit bus emul + swap support with 1MB pages .... (0) 



laun	dc.b	"PILA",0
* intron  	dc.b	"CONQIN.FIC",0

chagln   	dc.b  	"C:\GAMEX\"
hagln	dc.b	"HAGA",0

subdif	dc.b	"FILES",0
    even




 


pmess      pea  (a0)
	move.w  #9,-(sp)
	trap   #1
	addq.l  #6,sp
	rts


 





clearkb	move.w	#11,-(sp)   *Cconis
	trap	#1
	addq.l	#2,sp
	tst.l	d0
	beq.s	nocha

	move.w	#7,-(sp)   *Crawcin
	trap	#1
	addq.l	#2,sp
	bra.s	clearkb

nocha	rts



hwpal   *Palette for HW show :
  

   dc.w   $562,$7,$7,$7,$7,$7,$7,$7
   dc.w   $7,$7,$7,$7,$7,$7,$7,7




noEnoR
	lea	noEnrt(pc),a0
	bra.s	exitC

tooMLR	
	lea	tooMLRm(pc),a0
	bra.s	exitC

exitu 
	lea	misFt(pc),a0
exitC	bsr	pmess

* wait keypress :
	move.w	#1,-(sp)
	trap	#1


	clr.w -(sp)
	trap #1


DeskRes	dc.w 	0

ttSpeedT  dc.b  13,10,"TT speed=6",0


gamext  dc.b   13,10,13,10,"Exit to Desktop:  * on NumPad",13,10
	dc.b  "Save gamestate:  / on NumPad",27,"H",0

cheatt   dc.b  27,"H","Press L for unlimited lives",0
*	dc.b  "S for unlimited strength",0
*	dc.b   "B for both",0




misFt	dc.b   "Some file(s) missing.",13,10
	dc.b  "Please reinstall from ZIP.",0

  IFEQ   ram1m
noEnrt	dc.b  "Min RAM for this is 1MB.",0
  ENDC

  IFNE   ram1m
noEnrt	dc.b  "Min RAM for this is 2MB.",0
  ENDC

tooMLRm	dc.b  "Too much low RAM occupied.",13,10
	dc.b   "Read usage how to fix it.",0

    even




screnb  ds.l    1


photoc

* Flexible overscan - up to 273 lines



* 320x228-273   overscan 


lines	equ	240    * Vertical res.  Write here for particular title !
ovsDel	equ	173   * For 240 lines

* Formula for calculating ovsDel :  

* (273 - verticalRes) x 64 /26.04 + 92 

	
   include  "OVSSH.S"    *  For over 228  lines OVS





  section data

* Correct filenames by need  :

picfn	dc.b	"FPI240.HST",0
ttfPic	dc.b	"PI240D.BMP",0
  even


 
  section  bss

palsav	ds.b  32

   ds.b  512    * stack space
 
hagaLD   







